# Class Monitor

java.lang.Object
com.codename1.ui.Monitor

public final class Monitor extends Object

One physical display attached to the desktop.

A `Window` sits on exactly one monitor at a time and takes its scale and density from that monitor, so two windows of the same application can legitimately render at different scales. Obtain instances through `Desktop#getMonitors()`.

Instances are snapshots. A monitor that is unplugged, moved or has its resolution changed produces a fresh set, announced through `Desktop#addMonitorListener(com.codename1.ui.events.ActionListener)`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `equals(Object other)`
  Indicates whether some other object is "equal to" this one.
  `Rectangle`
  `getBounds()`
  Returns the monitor's full area in desktop coordinates.
  `int`
  `getDensity()`
  Returns the density bucket of this monitor, as one of the `Display` density constants.
  `int`
  `getDotsPerInch()`
  Returns the resolution of this monitor in dots per inch.
  `String`
  `getName()`
  Returns a name for this monitor suitable for showing to a person.
  `double`
  `getScale()`
  Returns the backing scale of this monitor: one for a conventional display, two for a high resolution one, and fractional values on platforms that allow them.
  `Rectangle`
  `getWorkArea()`
  Returns the part of the monitor that is actually usable by a window, with the task bar, dock and any reserved panels excluded.
  `int`
  `hashCode()`
  Returns a hash code value for the object.
  `boolean`
  `isPrimary()`
  Indicates whether this is the primary monitor, the one the platform treats as the origin of the desktop.
  `String`
  `toString()`
  Returns a string representation of the object.

  ### Methods inherited from class Object

  `clone, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### getBounds

    public Rectangle getBounds()

    Returns the monitor's full area in desktop coordinates.

    Desktop coordinates span every monitor, so a secondary display placed left of or above the primary one legitimately has a negative origin.

    ###### Returns

    a copy of the monitor bounds

  - ### getWorkArea

    public Rectangle getWorkArea()

    Returns the part of the monitor that is actually usable by a window, with the task bar, dock and any reserved panels excluded.

    Prefer this over `#getBounds()` when placing or maximising a window.

    ###### Returns

    a copy of the usable area

  - ### getDensity

    public int getDensity()

    Returns the density bucket of this monitor, as one of the `Display` density constants.

    ###### Returns

    the density constant

  - ### getScale

    public double getScale()

    Returns the backing scale of this monitor: one for a conventional display, two for a high resolution one, and fractional values on platforms that allow them.

    ###### Returns

    the scale factor

  - ### getDotsPerInch

    public int getDotsPerInch()

    Returns the resolution of this monitor in dots per inch.

    ###### Returns

    the dots per inch

  - ### getName

    public String getName()

    Returns a name for this monitor suitable for showing to a person.

    ###### Returns

    the monitor name

  - ### isPrimary

    public boolean isPrimary()

    Indicates whether this is the primary monitor, the one the platform treats as the origin of the desktop.

    ###### Returns

    true if this is the primary monitor

  - ### equals

    public boolean equals(Object other)

    Indicates whether some other object is "equal to" this one. The equals method implements an equivalence relation: It is reflexive: for any reference value x, x.equals(x) should return true. It is symmetric: for any reference values x and y, x.equals(y) should return true if and only if y.equals(x) returns true. It is transitive: for any reference values x, y, and z, if x.equals(y) returns true and y.equals(z) returns true, then x.equals(z) should return true. It is consistent: for any reference values x and y, multiple invocations of x.equals(y) consistently return true or consistently return false, provided no information used in equals comparisons on the object is modified. For any non-null reference value x, x.equals(null) should return false. The equals method for class Object implements the most discriminating possible equivalence relation on objects; that is, for any reference values x and y, this method returns true if and only if x and y refer to the same object (x==y has the value true).

    Every property counts, not just the index and the bounds. A monitor can be reconfigured without either changing -- display scaling adjusted, a taskbar switched to auto-hide, a monitor promoted to primary -- and `Desktop` reports that and hands out fresh snapshots. Comparing only index and bounds made the new snapshot equal to the old one, so anything that caches `getMonitors()` and uses equality to spot what changed kept the stale scale or work area.

    Overrides:
      `equals` in class `Object`

  - ### hashCode

    public int hashCode()
    Returns a hash code value for the object. This method is supported for the benefit of hashtables such as those provided by java.util.Hashtable. The general contract of hashCode is: Whenever it is invoked on the same object more than once during an execution of a Java application, the hashCode method must consistently return the same integer, provided no information used in equals comparisons on the object is modified. This integer need not remain consistent from one execution of an application to another execution of the same application. If two objects are equal according to the equals(Object) method, then calling the hashCode method on each of the two objects must produce the same integer result. It is not required that if two objects are unequal according to the equals(java.lang.Object) method, then calling the hashCode method on each of the two objects must produce distinct integer results. However, the programmer should be aware that producing distinct integer results for unequal objects may improve the performance of hashtables. As much as is reasonably practical, the hashCode method defined by class Object does return distinct integers for distinct objects. (This is typically implemented by converting the internal address of the object into an integer, but this implementation technique is not required by the JavaTM programming language.)
    Overrides:
      `hashCode` in class `Object`

  - ### toString

    public String toString()
    Returns a string representation of the object. In general, the toString method returns a string that "textually represents" this object. The result should be a concise but informative representation that is easy for a person to read. It is recommended that all subclasses override this method. The toString method for class Object returns a string consisting of the name of the class of which the object is an instance, the at-sign character `@', and the unsigned hexadecimal representation of the hash code of the object. In other words, this method returns a string equal to the value of: getClass().getName() + '@' + Integer.toHexString(hashCode())
    Overrides:
      `toString` in class `Object`